/* IFSLab.h - Copyright (C) 1992 by N. Zeldes. All rights reserved */
/* Version 1.0, 29 Feb 1992 */

struct TextAttr TOPAZ80 = {
  (STRPTR)"topaz.font",
  TOPAZ_EIGHTY,0,0
};

struct NewScreen NewScreenStructure = {
  0,0,  /* screen XY origin relative to View */
  320,200,  /* screen width and height */
  4,  /* screen depth (number of bitplanes) */
  3,1,  /* detail and block pens */
  NULL,  /* display modes for this screen */
  CUSTOMSCREEN,  /* screen type */
  &TOPAZ80,  /* pointer to default screen font */
  (UBYTE *)"           Outline Editor",  /* screen title */
  NULL,  /* first in list of custom screen gadgets */
  NULL  /* pointer to custom BitMap structure */
};

#define NEWSCREENSTRUCTURE NewScreenStructure

USHORT Palette[] = {
  0x0000,  /* color #0 */
  0x0080,  /* color #1 */
  0x0ECA,  /* color #2 */
  0x08F0,  /* color #3 */
  0x0F00,  /* color #4 */
  0x0F00,  /* color #5 */
  0x0F00,  /* color #6 */
  0x0F00,  /* color #7 */
  0x0990,  /* color #8 */
  0x07D0,  /* color #9 */
  0x0080,  /* color #10 */
  0x0444,  /* color #11 */
  0x0FFF,  /* color #12 */
  0x0080,  /* color #13 */
  0x0444,  /* color #14 */
  0x0990  /* color #15 */
#define PaletteColorCount 16
};

#define PALETTE Palette

SHORT LogoBorderVectors[] = {
  0,0,
  36,0,
  36,77,
  0,77,
  0,1,
  35,1,
  35,76,
  1,76,
  1,1
};
struct Border LogoBorder = {
  280,120,  /* XY origin relative to container TopLeft */
  1,0,JAM1,  /* front pen, back pen and drawmode */
  9,  /* number of XY vectors */
  LogoBorderVectors,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct Gadget LogoBorderGadg = {  /* Dummy Gadget for drawing IFS Logo Border */
  NULL,  /* next gadget */
  0,0,  /* origin XY of hit box relative to window TopLeft */
  1,1,  /* hit box width and height */
  GADGHNONE+GADGDISABLED,  /* gadget flags */
  NULL,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&LogoBorder,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  NULL,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  997,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

USHORT LogoImageData[] =
{

0xFFFF,0xFFFF,0x8000,0xFFFF,0xFFFF,0x8000,
0xFFFF,0xFFFF,0x8000,0xF818,0x0E1F,0x8000,
0xFE7C,0xCCCF,0x8000,0xFE7C,0xFC7F,0x8000,
0xFE7C,0x3E3F,0x8000,0xFE7C,0xFF8F,0x8000,
0xFE7C,0xFCCF,0x8000,0xF818,0x7E1F,0x8000,
0xFFFF,0xFFFF,0x8000,0xFFFF,0xFFFF,0x8000,
0xFFFF,0xFFFF,0x8000,0xFFFF,0xDFFF,0x8000,
0xFFFF,0xDFFF,0x8000,0xFFFF,0x9FFF,0x8000,
0xFFFF,0x8FFF,0x8000,0xFFFF,0x0FFF,0x8000,
0xFFFF,0x0FFF,0x8000,0xFFFE,0x0FFF,0x8000,
0xFFFE,0x07FF,0x8000,0xFFFD,0x07FF,0x8000,
0xFFFD,0xC7FF,0x8000,0xFFF9,0xF3FF,0x8000,
0xFFF9,0xFBFF,0x8000,0xFFF1,0xFFFF,0x8000,
0xFFF0,0xF9FF,0x8000,0xFFE0,0xF1FF,0x8000,
0xFFE0,0xF1FF,0x8000,0xFFC0,0xE1FF,0x8000,
0xFFD8,0x40FF,0x8000,0xFF9E,0x40FF,0x8000,
0xFF9F,0x80FF,0x8000,0xFF1F,0xE0FF,0x8000,
0xFF1F,0xF87F,0x8000,0xFE0F,0xFE7F,0x8000,
0xFE0F,0xFF7F,0x8000,0xFC0F,0xFFFF,0x8000,
0xFC0F,0xFF3F,0x8000,0xFA0F,0xFF3F,0x8000,
0xFB87,0xFE3F,0x8000,0xF3E7,0xFE3F,0x8000,
0xF1FF,0xFC1F,0x8000,0xE1FB,0xFC1F,0x8000,
0xE1F3,0xF81F,0x8000,0xC1F3,0xF81F,0x8000,
0xC1E3,0xF60F,0x8000,0xE0C3,0xF78F,0x8000,
0xF8C1,0xE3EF,0x8000,0xFE81,0xE3F7,0x8000,
0xFF81,0xC3F7,0x8000,0xFFE1,0xC3E7,0x8000,
0xFFF8,0x81E7,0x8000,0xFFFE,0x01C7,0x8000,
0xFFFF,0x81C3,0x8000,0xFFFF,0xE083,0x8000,
0xFFFF,0xF883,0x8000,0xFFFF,0xFF03,0x8000,
0xFFFF,0xFF81,0x8000,0xFFFF,0xFFE1,0x8000,
0xFFFF,0xFFF9,0x8000,0xFFFF,0xFFFF,0x8000,
0xFFFF,0xFFFF,0x8000,0xFFFF,0xFFFF,0x8000,
0xF87F,0x381F,0x8000,0xFCFE,0x1CCF,0x8000,
0xFCFE,0x1CCF,0x8000,0xFCFC,0xCC1F,0x8000,
0xFCEC,0x0CCF,0x8000,0xFCC9,0xE4CF,0x8000,
0xF809,0xE01F,0x8000,0xFFFF,0xFFFF,0x8000,
0xFFFF,0xFFFF,0x8000,0xFFFF,0xFFFF,0x8000,
0x776F,0x726B,0x696E,0x672E,0x2E2E,0x6E6C,
0x792E,0x0A0A,0x2062,0x6520,0x6672,0x6565,
0x6C79,0x2064,0x6973,0x7472,0x6962,0x7574,
0x6564,0x2066,0x6F72,0x206E,0x6F6E,0x2D70,
0x726F,0x6669,0x740A,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,0xABAB,
};

struct Image LogoImage =
{
0,0,          /* LeftEdge, TopEdge */
33,74,1,      /* Width, Height, Depth */
&LogoImageData[0],
8, 3,        /* PlanePick, PlaneOnOff */
NULL,        /* Pointer to next Image */
};

struct Gadget LogoGadg = {    /* Dummy Gadget for drawing IFS Logo Image */
  &LogoBorderGadg,  /* next gadget */
  282,122,  /* origin XY of hit box relative to window TopLeft */
  1,1,  /* hit box width and height */
  GADGIMAGE+GADGHNONE+GADGDISABLED,  /* gadget flags */
  NULL,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&LogoImage,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  NULL,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  998,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT BorderVectors1[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border Border1 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  BorderVectors1,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText IText1 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  3,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Done",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget DoneGadg = {
  &LogoGadg,  /* next gadget */
  280,102,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&Border1,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &IText1,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  5,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT BorderVectors2[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border Border2 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  BorderVectors2,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText IText2 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Clr",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget ClrOutGadg = {
  &DoneGadg,  /* next gadget */
  280,84,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&Border2,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &IText2,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  4,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT BorderVectors3[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border Border3 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  BorderVectors3,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText IText3 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  3,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Fill",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget FillGadg = {
  &ClrOutGadg,  /* next gadget */
  280,66,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&Border3,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &IText3,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  3,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT BorderVectors4[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border Border4 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  BorderVectors4,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText IText4 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"xxx",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget EraseGadg = {
  &FillGadg,  /* next gadget */
  280,48,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&Border4,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &IText4,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  2,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT BorderVectors5[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border Border5 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  BorderVectors5,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText IText5 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  3,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Line",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget LineGadg = {
  &EraseGadg,  /* next gadget */
  280,30,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&Border5,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &IText5,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  1,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT BorderVectors6[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border Border6 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  BorderVectors6,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText IText6 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  3,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Free",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget FreeGadg = {
  &LineGadg,  /* next gadget */
  280,12,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&Border6,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &IText6,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  0,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

#define GadgetList1 FreeGadg

struct IntuiText IText7 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Demo",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem4 = {
  NULL,  /* next MenuItem structure */
  0,30,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  82,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText7,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText8 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Author",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem3 = {
  &MenuItem4,  /* next MenuItem structure */
  0,20,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  82,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText8,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText9 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Help",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem2 = {
  &MenuItem3,  /* next MenuItem structure */
  0,10,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  82,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText9,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText10 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"IFS Theory",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem1 = {
  &MenuItem2,  /* next MenuItem structure */
  0,0,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  82,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText10,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct Menu Menu4 = {
  NULL,  /* next Menu structure */
  218,0,  /* XY origin of Menu hit box relative to screen TopLeft */
  55,0,  /* Menu hit box width and height */
  MENUENABLED,  /* Menu flags */
  " About",  /* text of Menu name */
  &MenuItem1  /* MenuItem linked list pointer */
};

struct IntuiText IText11 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Start",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem7 = {
  NULL,  /* next MenuItem structure */
  0,20,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  90,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText11,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText12 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  19,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"16",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem4 = {
  NULL,  /* next SubItem structure */
  46,39,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  38,10,  /* hit box width and height */
  CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  7,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText12,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText13 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  19,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"8",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem3 = {
  &SubItem4,  /* next SubItem structure */
  46,29,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  38,10,  /* hit box width and height */
  CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  11,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText13,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText14 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  19,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"4",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem2 = {
  &SubItem3,  /* next SubItem structure */
  46,19,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  38,10,  /* hit box width and height */
  CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  13,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText14,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText15 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  19,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"2",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem1 = {
  &SubItem2,  /* next SubItem structure */
  46,9,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  38,10,  /* hit box width and height */
  CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP+CHECKED,  /* Item flags */
  14,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText15,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText16 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Gray Levels",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem6 = {
  &MenuItem7,  /* next MenuItem structure */
  0,10,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  90,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText16,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  &SubItem1,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText17 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  19,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"640x400",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem8 = {
  NULL,  /* next SubItem structure */
  46,29,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  76,10,  /* hit box width and height */
  CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP+CHECKED,  /* Item flags */
  3,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText17,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText18 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  19,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"640x200",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem7 = {
  &SubItem8,  /* next SubItem structure */
  46,19,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  76,10,  /* hit box width and height */
  CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  5,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText18,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText20 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  19,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"320x200",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem5 = {
  &SubItem7,  /* next SubItem structure */
  46,9,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  76,10,  /* hit box width and height */
  CHECKIT+ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  6,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText20,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText21 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Resolution",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem5 = {
  &MenuItem6,  /* next MenuItem structure */
  0,0,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  90,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText21,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  &SubItem5,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct Menu Menu3 = {
  &Menu4,  /* next Menu structure */
  152,0,  /* XY origin of Menu hit box relative to screen TopLeft */
  63,0,  /* Menu hit box width and height */
  MENUENABLED,  /* Menu flags */
  " Render",  /* text of Menu name */
  &MenuItem5  /* MenuItem linked list pointer */
};

struct IntuiText IText22 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Show Image",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem9 = {
  NULL,  /* next MenuItem structure */
  0,10,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  80,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText22,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText23 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Show Codes",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem8 = {
  &MenuItem9,  /* next MenuItem structure */
  0,0,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  80,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText23,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct Menu Menu2 = {
  &Menu3,  /* next Menu structure */
  80,0,  /* XY origin of Menu hit box relative to screen TopLeft */
  70,0,  /* Menu hit box width and height */
  MENUENABLED,  /* Menu flags */
  " Display",  /* text of Menu name */
  &MenuItem8  /* MenuItem linked list pointer */
};

struct IntuiText IText24b = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Quit        ",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem14b = {
  NULL,  /* next MenuItem structure */
  0,60,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  100,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText24b,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText24 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Optimize    ",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem14 = {
  &MenuItem14b, /* next MenuItem structure */
  0,40,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  100,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText24,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText26 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Image",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem10 = {
  NULL,  /* next SubItem structure */
  50,9,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  60,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText26,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText27 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"IFS",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem9 = {
  &SubItem10,  /* next SubItem structure */
  50,-1,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  60,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText27,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText28 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Save File   ",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem13 = {
  &MenuItem14,  /* next MenuItem structure */
  0,30,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  100,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText28,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  &SubItem9,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText29 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Image",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem14 = {
  NULL,  /* next SubItem structure */
  50,19,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  60,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText29,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText30 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"IFS",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem13 = {
  &SubItem14,  /* next SubItem structure */
  50,9,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  60,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText30,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText31 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Outline",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem SubItem12 = {
  &SubItem13,  /* next SubItem structure */
  50,-1,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  60,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText31,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* no SubItem list for SubItems */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText32 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Load File   ",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem12 = {
  &MenuItem13,  /* next MenuItem structure */
  0,20,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  100,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText32,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  &SubItem12,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText33 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Edit Outline",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem11 = {
  &MenuItem12,  /* next MenuItem structure */
  0,10,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  100,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText33,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct IntuiText IText34 = {
  3,1,JAM2,  /* front and back text pens, drawmode and fill byte */
  0,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"New",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct MenuItem MenuItem10 = {
  &MenuItem11,  /* next MenuItem structure */
  0,0,  /* XY of Item hitbox relative to TopLeft of parent hitbox */
  100,10,  /* hit box width and height */
  ITEMTEXT+ITEMENABLED+HIGHCOMP,  /* Item flags */
  0,  /* each bit mutually-excludes a same-level Item */
  (APTR)&IText34,  /* Item render  (IntuiText or Image or NULL) */
  NULL,  /* Select render */
  NULL,  /* alternate command-key */
  NULL,  /* SubItem list */
  MENUNULL  /* filled in by Intuition for drag selections */
};

struct Menu Menu1 = {
  &Menu2,  /* next Menu structure */
  10,0,  /* XY origin of Menu hit box relative to screen TopLeft */
  70,0,  /* Menu hit box width and height */
  MENUENABLED,  /* Menu flags */
  " Project ",  /* text of Menu name */
  &MenuItem10  /* MenuItem linked list pointer */
};

#define MenuList1 Menu1

struct NewWindow NewWindowStructure1 = {
  0,0,  /* window XY origin relative to TopLeft of screen */
  320,200,  /* window width and height */
  3,1,  /* detail and block pens */
  MOUSEBUTTONS+GADGETUP+MENUPICK,  /* IDCMP flags */
  GIMMEZEROZERO+ACTIVATE+BACKDROP,  /* other window flags */
  &FreeGadg,  /* first gadget in gadget list */
  NULL,  /* custom CHECKMARK imagery */
  (UBYTE *)" ",  /* window title */
  NULL,  /* custom screen pointer */
  NULL,  /* custom bitmap */
  5,5,  /* minimum width and height */
  -1,-1,  /* maximum width and height */
  CUSTOMSCREEN  /* destination screen type */
};

SHORT CollageBorderVectors7[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border CollageBorder7 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  CollageBorderVectors7,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText CollageIText35 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Num",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget CollageNumGadg = {
  &LogoGadg,  /* next gadget */
  280,102,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&CollageBorder7,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &CollageIText35,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  11,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT CollageBorderVectors8[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border CollageBorder8 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  CollageBorderVectors8,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText CollageIText36 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Clr",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget CollageClrIFSGadg = {
  &CollageNumGadg,  /* next gadget */
  280,84,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&CollageBorder8,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &CollageIText36,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  10,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT CollageBorderVectors9[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border CollageBorder9 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  CollageBorderVectors9,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText CollageIText37 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Del",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget CollageDelGadg = {
  &CollageClrIFSGadg,  /* next gadget */
  280,66,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&CollageBorder9,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &CollageIText37,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  9,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT CollageBorderVectors10[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border CollageBorder10 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  CollageBorderVectors10,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText CollageIText38 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Sel",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget CollageSelGadg = {
  &CollageDelGadg,  /* next gadget */
  280,48,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&CollageBorder10,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &CollageIText38,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  8,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT CollageBorderVectors11[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border CollageBorder11 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  CollageBorderVectors11,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText CollageIText39 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Dup",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget CollageDupGadg = {
  &CollageSelGadg,  /* next gadget */
  280,30,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&CollageBorder11,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &CollageIText39,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  7,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

SHORT CollageBorderVectors12[] = {
  0,0,
  36,0,
  36,15,
  0,15,
  0,1
};
struct Border CollageBorder12 = {
  0,0,  /* XY origin relative to container TopLeft */
  3,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  CollageBorderVectors12,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText CollageIText40 = {
  3,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  6,4,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Add",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget CollageAddGadg = {
  &CollageDupGadg,  /* next gadget */
  280,12,  /* origin XY of hit box relative to window TopLeft */
  37,16,  /* hit box width and height */
  NULL,  /* gadget flags */
  RELVERIFY+RIGHTBORDER,  /* activation flags */
  BOOLGADGET+GZZGADGET,  /* gadget type flags */
  (APTR)&CollageBorder12,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &CollageIText40,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  6,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

#define CollageGadgetList2 CollageAddGadg

SHORT NumBorderVectors13[] = {
  0,0,
  49,0,
  49,12,
  0,12,
  0,1
};
struct Border NumBorder13 = {
  0,0,  /* XY origin relative to container TopLeft */
  9,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors13,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText41 = {
  9,0,JAM2,  /* front and back text pens, drawmode and fill byte */
  5,3,  /* XY origin relative to container TopLeft */
  NULL,  /* font pointer or NULL for default */
  (UBYTE *)"ENTER",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumEnterGadg = {
  NULL,  /* next gadget */
  15,181,  /* origin XY of hit box relative to window TopLeft */
  50,13,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY,  /* activation flags */
  BOOLGADGET,  /* gadget type flags */
  (APTR)&NumBorder13,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText41,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  NULL,  /* SpecialInfo structure */
  12,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumT2coeffGadgSIBuff[12];
struct StringInfo NumNumT2coeffGadgSInfo = {
  NumNumT2coeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors14[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder14 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors14,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText42 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -20,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"t2",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumT2coeffGadg = {
  &NumEnterGadg,  /* next gadget */
  26,167,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder14,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText42,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumT2coeffGadgSInfo,  /* SpecialInfo structure */
  34,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumT1coeffGadgSIBuff[12];
struct StringInfo NumNumT1coeffGadgSInfo = {
  NumNumT1coeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors15[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder15 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors15,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText43 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -20,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"t1",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumT1coeffGadg = {
  &NumT2coeffGadg,  /* next gadget */
  26,156,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder15,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText43,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumT1coeffGadgSInfo,  /* SpecialInfo structure */
  33,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumR2coeffGadgSIBuff[12];
struct StringInfo NumNumR2coeffGadgSInfo = {
  NumNumR2coeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors16[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder16 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors16,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText44 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -20,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"r2",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumR2coeffGadg = {
  &NumT1coeffGadg,  /* next gadget */
  26,145,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder16,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText44,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumR2coeffGadgSInfo,  /* SpecialInfo structure */
  32,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumR1coeffGadgSIBuff[12];
struct StringInfo NumNumR1coeffGadgSInfo = {
  NumNumR1coeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors17[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder17 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors17,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText45 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -20,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"r1",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumR1coeffGadg = {
  &NumR2coeffGadg,  /* next gadget */
  26,134,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder17,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText45,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumR1coeffGadgSInfo,  /* SpecialInfo structure */
  31,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumS2coeffGadgSIBuff[12];
struct StringInfo NumNumS2coeffGadgSInfo = {
  NumNumS2coeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors18[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder18 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors18,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText46 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -20,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"s2",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumS2coeffGadg = {
  &NumR1coeffGadg,  /* next gadget */
  26,123,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder18,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText46,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumS2coeffGadgSInfo,  /* SpecialInfo structure */
  30,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumS1coeffGadgSIBuff[12];
struct StringInfo NumNumS1coeffGadgSInfo = {
  NumNumS1coeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors19[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder19 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors19,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText47 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -20,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"s1",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumS1coeffGadg = {
  &NumS2coeffGadg,  /* next gadget */
  26,112,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder19,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText47,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumS1coeffGadgSInfo,  /* SpecialInfo structure */
  29,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumPcoeffGadgSIBuff[12];
struct StringInfo NumNumPcoeffGadgSInfo = {
  NumNumPcoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors20[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder20 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors20,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText48 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -16,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"P",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumPcoeffGadg = {
  &NumS1coeffGadg,  /* next gadget */
  26,95,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder20,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText48,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumPcoeffGadgSInfo,  /* SpecialInfo structure */
  28,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumDenscoeffGadgSIBuff[10];
struct StringInfo NumNumDenscoeffGadgSInfo = {
  NumNumDenscoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  10,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors21[] = {
  0,0,
  41,0,
  41,9,
  0,9,
  0,0
};
struct Border NumBorder21 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors21,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText49 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -29,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"Den",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumDenscoeffGadg = {
  &NumPcoeffGadg,  /* next gadget */
  34,84,  /* origin XY of hit box relative to window TopLeft */
  40,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder21,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText49,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumDenscoeffGadgSInfo,  /* SpecialInfo structure */
  27,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumFcoeffGadgSIBuff[12];
struct StringInfo NumNumFcoeffGadgSInfo = {
  NumNumFcoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors22[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder22 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors22,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText50 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -16,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"F",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumFcoeffGadg = {
  &NumDenscoeffGadg,  /* next gadget */
  26,68,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder22,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText50,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumFcoeffGadgSInfo,  /* SpecialInfo structure */
  26,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumEcoeffGadgSIBuff[12];
struct StringInfo NumNumEcoeffGadgSInfo = {
  NumNumEcoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors23[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder23 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors23,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText51 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -16,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"E",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumEcoeffGadg = {
  &NumFcoeffGadg,  /* next gadget */
  26,57,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder23,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText51,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumEcoeffGadgSInfo,  /* SpecialInfo structure */
  25,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumDcoeffGadgSIBuff[12];
struct StringInfo NumNumDcoeffGadgSInfo = {
  NumNumDcoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors24[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder24 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors24,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText52 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -16,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"D",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumDcoeffGadg = {
  &NumEcoeffGadg,  /* next gadget */
  26,46,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder24,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText52,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumDcoeffGadgSInfo,  /* SpecialInfo structure */
  24,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumCcoeffGadgSIBuff[12];
struct StringInfo NumNumCcoeffGadgSInfo = {
  NumNumCcoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors25[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder25 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors25,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText53 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -16,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"C",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumCcoeffGadg = {
  &NumDcoeffGadg,  /* next gadget */
  26,35,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder25,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText53,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumCcoeffGadgSInfo,  /* SpecialInfo structure */
  23,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumBcoeffGadgSIBuff[12];
struct StringInfo NumNumBcoeffGadgSInfo = {
  NumNumBcoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors26[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder26 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors26,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText54 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -16,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"B",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumBcoeffGadg = {
  &NumCcoeffGadg,  /* next gadget */
  26,24,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder26,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText54,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumBcoeffGadgSInfo,  /* SpecialInfo structure */
  22,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

UBYTE NumNumAcoeffGadgSIBuff[12];
struct StringInfo NumNumAcoeffGadgSInfo = {
  NumNumAcoeffGadgSIBuff,  /* buffer where text will be edited */
  NULL,  /* optional undo buffer */
  0,  /* character position in buffer */
  12,  /* maximum number of characters to allow */
  0,  /* first displayed character buffer position */
  0,0,0,0,0,  /* Intuition initialized and maintained variables */
  0,  /* Rastport of gadget */
  0,  /* initial value for integer gadgets */
  NULL  /* alternate keymap (fill in if you set the flag) */
};

SHORT NumBorderVectors27[] = {
  0,0,
  49,0,
  49,9,
  0,9,
  0,0
};
struct Border NumBorder27 = {
  -1,-1,  /* XY origin relative to container TopLeft */
  8,0,JAM1,  /* front pen, back pen and drawmode */
  5,  /* number of XY vectors */
  NumBorderVectors27,  /* pointer to XY vectors */
  NULL  /* next border in list */
};

struct IntuiText NumIText55 = {
  9,0,JAM1,  /* front and back text pens, drawmode and fill byte */
  -16,0,  /* XY origin relative to container TopLeft */
  &TOPAZ80,  /* font pointer or NULL for default */
  (UBYTE *)"A",  /* pointer to text */
  NULL  /* next IntuiText structure */
};

struct Gadget NumAcoeffGadg = {
  &NumBcoeffGadg,  /* next gadget */
  26,13,  /* origin XY of hit box relative to window TopLeft */
  48,8,  /* hit box width and height */
  NULL,  /* gadget flags */
  GADGIMMEDIATE+RELVERIFY+STRINGRIGHT,  /* activation flags */
  STRGADGET,  /* gadget type flags */
  (APTR)&NumBorder27,  /* gadget border or image to be rendered */
  NULL,  /* alternate imagery for selection */
  &NumIText55,  /* first IntuiText structure */
  NULL,  /* gadget mutual-exclude long word */
  (APTR)&NumNumAcoeffGadgSInfo,  /* SpecialInfo structure */
  21,  /* user-definable data */
  NULL  /* pointer to user-definable data */
};

#define NumGadgetList3 NumAcoeffGadg

struct NewWindow NumNewWindowStructure3 = {
  0,0,  /* window XY origin relative to TopLeft of screen */
  80,200,  /* window width and height */
  3,1,  /* detail and block pens */
  GADGETUP+GADGETDOWN+CLOSEWINDOW,  /* IDCMP flags */
  WINDOWDRAG+WINDOWCLOSE+ACTIVATE,  /* other window flags */
  &NumAcoeffGadg,  /* first gadget in gadget list */
  NULL,  /* custom CHECKMARK imagery */
  (UBYTE *)"",  /* window title */
  NULL,  /* custom screen pointer */
  NULL,  /* custom bitmap */
  5,5,  /* minimum width and height */
  -1,-1,  /* maximum width and height */
  CUSTOMSCREEN  /* destination screen type */
};
